function as = cmw_conv(data,cmw)

% dumb function that takes Mikes code and does the convlusiton in the
% frequency domain
%
% input data is a vector 1 x timepoints
%
% cmw is complex morlet wavelet
%
% as is analytical signal, complex output of convoultion that
% allows us to obtain real, magnitude, and phase signals

%% define convolution parameters
nData = length(data);
nKern = length(cmw);
nConv = nData + nKern - 1;
half_wav = floor( length(cmw)/2 )+1;

%% FFTs

% note that the "N" parameter is the length of convolution, NOT the length
% of the original signals! Super-important!


% FFT of wavelet, and amplitude-normalize in the frequency domain
cmwX = fft(cmw,nConv);
cmwX = cmwX ./ max(cmwX);

% FFT of data
dataX = fft(data,nConv);

% now for convolution...
as = ifft( dataX .* cmwX );

% cut 1/2 of the length of the wavelet from the beginning and from the end
as = as(half_wav-1:end-half_wav);
end